
#include "Vector/Vector.hpp"
#include <Graphics/Graphics.hpp>
#include "Character3D.hpp"

class Camera
{
	Vector3f position,axis;
	Vector3f targetPos,eye,up;
	float gluAngle,Angle,nearPlane,farPlane;
	bool follow;
	Vector3f followPos,followOffset_b,followOffset_f;

	public:
		Camera(Vector3f pos, float angle,Vector3f hpr,float near,float far,float gluangle);
		~Camera();
		void Draw();
		Vector3f getPos();
		Vector3f getAxis();
		float getAngle();
		float getNearPlane();
		float getFarPlane();
		void setValues(Vector3f pos,float angle,Vector3f hpr,float npl,float fpl);
		void setTarget(Vector3f tPos);
		void setAngle(float angle);
		void setEye(Vector3f eyePos);
		void Update(Character3D player);
		void Follow(Character3D player, Vector3f boffset,Vector3f foffset);
		void stopFollow();
};
