
#include "Character3D.hpp"
#include <math.h>

GLUquadricObj *quadratic;

Vector3f VecSum(Vector3f a,Vector3f b)
{
	Vector3f c;
	c.x = a.x + b.x;
	c.y = a.y + b.y;
	c.z = a.z + b.z;	
	return c;
}

Vector3f VecMultScalar(Vector3f a,float b)
{
	Vector3f c;
	c.x = a.x * b;
	c.y = a.y * b;
	c.z = a.z * b;	
	return c;
}

Player3D::~Player3D()
{

}

Enemy3D::~Enemy3D()
{

}

Character3D::Character3D(Vector3f pos, Vector3f hpr, Vector3f vel, float m, float r, float size)
{
	position = pos;
	orientation = hpr;
	velocity = vel;
	mass = m;
	radius = r;
	startMove = false;
	Size = size;
}

Character3D::~Character3D()
{


}

bool Character3D::detectCollision(Character3D collider)
{
	float distance = sqrt(pow((collider.position.x - this->position.x),2) + 
				pow((collider.position.y - this->position.y),2) +
				 pow((collider.position.z - this->position.z),2));
	
	if(distance < ((this->Size + collider.Size)))
		return true;
	
	return false;
}

void Character3D::Draw(float r,float g,float b)
{
	DrawBox(position.x,position.y,position.z,r,g,b,Size);
}

void Character3D::Update()
{

	if(startMove)
	{
		position = VecSum(position,VecMultScalar(direction,acceleration));
	}
	
}

void Character3D::Move(Vector3f dirn, float force)
{
	startMove = true;
	acceleration = force/mass;	
	direction = dirn;
}

Vector3f Character3D::getPos()
{	
	return position;
}

Vector3f Character3D::getHpr()
{
	return orientation;
}

void Character3D::setPos(Vector3f pos)
{
	position = pos;
}


void Character3D::setHpr(Vector3f hpr)
{
	orientation = hpr;
}

Vector3f Character3D::getVel()
{
	return velocity;
}

void Character3D::setVel(Vector3f vel)
{
	velocity = vel;
}


void Character3D::setMass(float m)
{
	mass = m;
}

void DrawSphere(float x,float y,float z,float r)
{

}

void DrawBox(float x,float y,float z,float r,float g,float b,float size)
{
	glPushMatrix();
	glColor3f(r,g,b);
	glTranslatef(x,y,z);
	glScalef(size,size,size);
	glBegin(GL_QUADS);	
		glVertex3f( 1.0f, 1.0f,-1.0f);
		glVertex3f(-1.0f, 1.0f,-1.0f);
		glVertex3f(-1.0f, 1.0f, 1.0f);
		glVertex3f( 1.0f, 1.0f, 1.0f);
		glVertex3f( 1.0f,-1.0f, 1.0f);
		glVertex3f(-1.0f,-1.0f, 1.0f);
		glVertex3f(-1.0f,-1.0f,-1.0f);
		glVertex3f( 1.0f,-1.0f,-1.0f);	
		glVertex3f( 1.0f, 1.0f, 1.0f);
		glVertex3f(-1.0f, 1.0f, 1.0f);
		glVertex3f(-1.0f,-1.0f, 1.0f);
		glVertex3f( 1.0f,-1.0f, 1.0f);
		glVertex3f( 1.0f,-1.0f,-1.0f);
		glVertex3f(-1.0f,-1.0f,-1.0f);
		glVertex3f(-1.0f, 1.0f,-1.0f);
		glVertex3f( 1.0f, 1.0f,-1.0f);
		glVertex3f(-1.0f, 1.0f, 1.0f);
		glVertex3f(-1.0f, 1.0f,-1.0f);
		glVertex3f(-1.0f,-1.0f,-1.0f);
		glVertex3f(-1.0f,-1.0f, 1.0f);
		glVertex3f( 1.0f, 1.0f,-1.0f);
		glVertex3f( 1.0f, 1.0f, 1.0f);
		glVertex3f( 1.0f,-1.0f, 1.0f);
		glVertex3f( 1.0f,-1.0f,-1.0f);
	glEnd();
	glPopMatrix();

}


