
#ifndef Char3D
#define Char3D

#include "Vector/Vector.hpp"
#include <Graphics/Graphics.hpp>

void DrawSphere(float x,float y,float z,float r);
void DrawBox(float x,float y,float z,float r,float g,float b,float size);

class Character3D
{
	Vector3f position,orientation,velocity,direction; 
	float gravity,mass,radius,acceleration;
	bool startMove;

	public:
		float Size;
		Character3D(Vector3f pos, Vector3f hpr, Vector3f vel, float m, float r, float size);
		~Character3D();
		virtual void Draw(float r,float g,float b);
		virtual void Update();
		virtual void Move(Vector3f direction, float force);
		Vector3f getPos();
		Vector3f getHpr();
		Vector3f getVel();
		void setPos(Vector3f pos);
		void setHpr(Vector3f hpr);
		void setVel(Vector3f vel);
		void setMass(float m);
		bool detectCollision(Character3D collider);
};

class Player3D:public Character3D
{
	public:
		Player3D(Vector3f pos, Vector3f hpr, Vector3f vel, float m, float r, float size):Character3D(pos,hpr,vel,m,r,size){}
		~Player3D();
		//void Draw(float r,float g,float b);
		//void Update();
};

class Enemy3D:public Character3D
{
	public:
		Enemy3D(Vector3f pos, Vector3f hpr, Vector3f vel, float m, float r, float size):Character3D(pos,hpr,vel,m,r,size){}
		~Enemy3D();
		//void Move(Vector3f direction, float force, bool loop);
		//void Update();
};

#endif
