
// TODO: Add sounds...

#include "Play.hpp"
#define EnemyNo 20

float ang = 0.0,pos = 1.0;
Camera *camera;
Vector3f position,axis,target,eye,vel;
Player3D *Player;
Enemy3D *Enemy[EnemyNo];
Timer *timer,*colorTimer;
Sound *bgSound,*hitSound;
bool startTimer = false,changecolor = false,enemyHit[EnemyNo],gameEnd = false,gameRestart = false;
float enemypos[EnemyNo][2] = {{0.0,50.0},{-5.0,100.0},{5.0,100.0},{3.0,150.0},{-3.0,150.0},
				{0.0,200.0},{-5.0,250.0},{5.0,250.0},{2.0,300.0},{-2.0,350.0},
				{0.0,400.0},{-5.0,400.0},{5.0,400.0},{3.0,450.0},{-3.0,500.0},
				{0.0,450.0},{2.0,340.0},{-4.0,320.0},{3.0,500.0},{5.0,200.0}};
float mouseX,mouseY;
unsigned int hitCounter = 0;
float flipTime = 2;

void DrawGrid(); //grid initial code referenced from nehe tutorials
void start();
void restart();

//////////////////////// Play class definitions ///////////////////////////////

Play::Play() {
	//sounds
	alutInit(0, NULL); // to initialize ALUT

	bgSound = new Sound("sounds/bgsoundnew.wav");
	hitSound = new Sound("sounds/hitsound.wav");
	bgSound->Start(true,0.01);

	start();
}

Play::~Play() {
	delete bgSound;
	delete hitSound;
	alutExit();  // to deinitialize alut
}

void Play::draw() {

	camera->Draw();

	if(!gameEnd && !gameRestart)
	{	
		//start Text
		glPushMatrix();
		glTranslatef(0.0,3.0,0.0);
		glRotatef(180,0,1,0);
		Graphics::FontRef font = Graphics::get_font("gentium.txf");
		assert(font.ref);

		glColor3f(0.0f, 1.0f, 0.0f);
		font->draw_center("PRESS 'SPACE' TO START", make_vector(0.0f, 0.5f), 0.3f);
		glColor3f(1.0f, 1.0f, 1.0f);
		font->draw_center("~ Move with the 'Mouse' ~", make_vector(0.0f, 0.8f), 0.3f);

		glPopMatrix();
	}	
	
	DrawGrid();

	if(!gameEnd)
	{
		if(changecolor && (colorTimer->getTime()<1))
			Player->Draw(1,1,1);
		else
			Player->Draw(0,0,0.75);
	}
	else
	{
		glPushMatrix();
		glTranslatef(0.0,3.0,0.0);
		glRotatef(180,0,1,0);
		Graphics::FontRef font = Graphics::get_font("gentium.txf");
		assert(font.ref);

		glColor3f(0.0f, 0.0f, 1.0f);
		font->draw_center("VICTORY!!!", make_vector(0.0f, 0.5f), 0.5f);
		glPopMatrix();
	}

	for(int i=0;i<EnemyNo;i++)
	{
		if(!enemyHit[i])
			Enemy[i]->Draw(1,0,0);
	}

	if(hitCounter>2)
	{
		glPushMatrix();
		glTranslatef(0.0,3.0,0.0);
		glRotatef(180,0,1,0);
		Graphics::FontRef font = Graphics::get_font("gentium.txf");
		assert(font.ref);

		glColor3f(1.0f, 0.0f, 0.0f);
		font->draw_center("~DESTROYED~ : GAME OVER !", make_vector(0.0f, 0.5f), 0.3f);
		glPopMatrix();
		gameRestart = true;
		camera->stopFollow();
	}

}



void Play::update(float elapsed_time) {
	camera->Update(*Player);
	Player->Update();
	if((!gameEnd && !gameRestart) && startTimer)
	{
		if(timer->getTime()>flipTime)
		{
			camera->setAngle(camera->getAngle() + 180);
			timer->startTimer();
		}
	}

	//detect collisions
	for(int i=0;i<EnemyNo;i++)
	{
		if(Player->detectCollision(*Enemy[i]))
		{
			changecolor = true;
			colorTimer->startTimer();
			if(!enemyHit[i])
			{
				hitSound->Start(false,0.1);
				hitCounter++;
			}
			enemyHit[i] = true;
		}
	}

	//end game
	if(Player->getPos().z > 500)
	{
		gameEnd = true;
		camera->stopFollow();
	}
}

// how to get smooth movt
void Play::handle_event(SDL_Event const &event) {
	//Handle events here:
		if (event.type == SDL_KEYDOWN) {
			switch(event.key.keysym.sym)
			{
				case SDLK_ESCAPE: 	{quit_screen(this); break; }
				/*case SDLK_UP: 	{
							position.set(Player->getPos().x,(Player->getPos().y,(Player->getPos().z + (++pos));
							Player->setPos(position);
							break; 
						}
				case SDLK_DOWN: {
							position.set(Player->getPos().x,(Player->getPos().y,(Player->getPos().z + (--pos));
							Player->setPos(position);
							break; 
						}*/
				/*
				case SDLK_LEFT: {
							position.set(Player->getPos().x  + pos,Player->getPos().y,Player->getPos().z);
							Player->setPos(position);
							break; 
						}
				case SDLK_RIGHT: {
							position.set(Player->getPos().x - pos,Player->getPos().y,Player->getPos().z);
							Player->setPos(position);
							break; 
						 }
				*/
				case SDLK_SPACE: {
							if(!gameRestart)
							{
								vel.set(0.0,0.0,1.0); // direction
								Player->Move(vel,7.0); // dirn, force
								startTimer = true;	
								timer->startTimer();
							}
							else
								restart();
							break; 
						 }
				//case SDLK_RETURN: 	{camera->setAngle(camera->getAngle() + 180);break; }
				default: break;
			}
		}

		if (startTimer && event.type == SDL_MOUSEMOTION) {
			mouseX = event.motion.x / float(Graphics::screen.x) * 2.0f * Graphics::aspectf() - Graphics::aspectf();
			mouseY = event.motion.y / float(Graphics::screen.y) *-2.0f + 1.0f;
			position.set(-mouseX * 5.0,Player->getPos().y,Player->getPos().z);
			Player->setPos(position);
		}
}

/********************** OTHER FUNCTIONS ******************************/

void DrawGrid()
{
	glColor4f(0,0,0.75,1);

	for(float i = -500; i <= 500; i += 5)
	{
		glBegin(GL_LINES);
			glColor3ub(150, 190, 150);							
			glVertex3f(-500, 0, i);									
			glVertex3f(500, 0, i);

			glVertex3f(i, 0, -500);								
			glVertex3f(i, 0, 500);
		glEnd();
	}	
		glColor3f(1.0,0.64,0.0);
		glBegin(GL_QUADS);
			glVertex3f(-10, 0, 500);									
			glVertex3f(-10, 0, 0);
			glVertex3f(-60, 0, 0);								
			glVertex3f(-60, 0, 500);

			glVertex3f(10, 0, 500);									
			glVertex3f(10, 0, 0);
			glVertex3f(60, 0, 0);								
			glVertex3f(60, 0, 500);
		glEnd();

		glColor3f(0.0,1.0,0.0);
		glBegin(GL_QUADS);
			glVertex3f(-10, 0, 500);									
			glVertex3f(-10, 0, 510);
			glVertex3f(10, 0, 510);								
			glVertex3f(10, 0, 500);
		glEnd();
}

void restart()
{
	delete timer;
	delete colorTimer;
	delete timer;
	delete camera;
	delete Player;
	for(int i=0;i<EnemyNo;i++)
		delete Enemy[i];
	start();
}

void start()
{

	//initializers
	startTimer = false;
	changecolor = false;
	gameEnd = false;
	gameRestart = false;
	hitCounter = 0;

	//Timer
	timer = new Timer();	
	colorTimer = new Timer();
	
	//Camera
	position.set(0.0f,0.0f,0.0f); //not used as of now
	axis.set(0.0f,1.0f,0.0f);
	camera = new Camera(position,0.0f,axis,0.5f,100.0f,45.0f);
	eye.set(0.0f,5.0f,-5.0f);
	target.set(0.0f,1.0f,3.0);
	camera->setEye(eye);
	camera->setTarget(target);

	//Player
	position.set(0.0f,0.0f,2.0f);  //pos
	axis.set(0.0f,0.0f,0.0f);   //hpr
	vel.set(0.0,0.0,5.0);    //vel
	Player = new Player3D(position,axis,vel,5.0f,2.0f,1.0f);

	//Enemy	
	axis.set(0.0f,0.0f,0.0f);
	vel.set(0.0,0.0,-5.0);

	for(int i=0;i<EnemyNo;i++)
	{
		position.set(enemypos[i][0],0.0,enemypos[i][1]);
		Enemy[i] = new Enemy3D(position,axis,vel,5.0f,2.0f,1.0f);
		enemyHit[i] = false;
	}

	//Make camera follow player  (using position and vel for offset_b and offset_f so as to not waste vars)
	position.set(0.0,5.0,-10.0);
	vel.set(0.0,1.0,3.0);
	camera->Follow(*Player,position,vel);

}


